/*#################################################################################################
##  |\   ======   /|  ##     Copyright (C) 2013-2014  Maurizio Sartori     ##  |\   ======   /|  ##
##  |__\========/__|  ##  ===============================================  ##  |__\========/__|  ##
##  |\            /|  ##     Written by:  Maurizio Sartori                 ##  |\            /|  ##
##  |  \        /  |  ##     e-mail:      masar@MasarLabs.com              ##  |  \        /  |  ##
##  |    \    /    |  ##     Site:        http://www.masarlabs.com         ##  |    \    /    |  ##
##  |    /=\/=\    |  ##  ===============================================  ##  |    /=\/=\    |  ##
##  |  /========\  |  ##     License GPLv3+: GNU GPL version 3 or later    ##  |  /========\  |  ##
##  |/   ======   \|  ##          http://gnu.org/licenses/gpl.html         ##  |/   ======   \|  ##
###################################################################################################
## $Id: network.h 4108 2014-02-06 17:10:52Z masar@masar $
#################################################################################################*/

#ifndef PATD_NETWORK_H
#define PATD_NETWORK_H 1

#include <stdint.h>
#include <sys/types.h>
#include <sys/socket.h>

/*************************************************************************************************/
/** Global Variables
**************************************************************************************************/

/*************************************************************************************************/
/** Global Macros
**************************************************************************************************/

/*************************************************************************************************/
/** Global Functions
**************************************************************************************************/
int openTcpClientSocket (const char * pchHost, const char * pchPort);
int openTcpServerSocket (const char * pchHost, const char * pchPort);
int setSocketNonBlocking (int fdSocket);

uint16_t icmpChecksum (const uint8_t * pBuffer, size_t iLen);

const char const * printSocketAddress (struct sockaddr * psa, ssize_t iSize);

int writeAll (int fdSocket, const void *p, size_t iCount);
int readAll (int fdSocket, const void *p, size_t iCount);

#endif
/*************************************************************************************************/
/*************************************************************************************************/
